export interface AuthMapperProtocol {
    me: string;
    register: string;
    logout: string;
    refresh: string;
    resendCode: string;
    resetPassword: string;
    requestPassword: string;
    role(data: any): string;
    toRegister(data: any): AuthUserTokenResponse;
    toRefresh(data: any): AuthTokenResponse;
}
export interface AuthTokenResponse {
    accessToken: string;
    refreshToken: string;
}
export interface AuthUserTokenResponse extends AuthTokenResponse {
    user: object;
}
