import { AuthProvider } from '../interfaces/provider.interface';
import { Api } from '@bravobit/bb-foundation/api';
export declare class AuthEmailProvider implements AuthProvider {
    private _email;
    private _password;
    private _endpoint;
    constructor(_email: string, _password: string, _endpoint?: string);
    authenticate(api: Api): Promise<{
        accessToken: any;
        refreshToken: any;
        user: any;
        provider: any;
        verifyToken: any;
    }>;
}
