import { ApplicationRef, ComponentFactoryResolver, Injector, Type } from '@angular/core';
import { BbDialogConfig } from './dialog.interfaces';
import { BbDialogRef } from './dialog.ref';
export declare class Dialog {
    private _injector;
    private _applicationRef;
    private _componentFactoryResolver;
    constructor(_injector: Injector, _applicationRef: ApplicationRef, _componentFactoryResolver: ComponentFactoryResolver);
    open<T = any>(componentType: Type<any>, config: BbDialogConfig): BbDialogRef<T>;
    confirm(title: string, description: string, options?: {
        cancelButtonText?: string;
        confirmButtonText?: string;
    }): BbDialogRef<boolean>;
    private createDialog;
    private deleteDialog;
}
