export interface StorageAttributes {
    expires?: Date | number;
}
export interface CookieStorageAttributes extends StorageAttributes {
    domain?: string;
    path?: string;
    secure?: boolean;
    sameSite?: 'strict' | 'lax';
}
export interface PolyfillStorageAttributes extends StorageAttributes {
}
export interface MemoryStorageAttributes extends StorageAttributes {
}
