(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('@angular/core'), require('@angular/common/http')) :
    typeof define === 'function' && define.amd ? define('@bravobit/bb-foundation/api', ['exports', 'rxjs', 'rxjs/operators', '@angular/core', '@angular/common/http'], factory) :
    (global = global || self, factory((global.bravobit = global.bravobit || {}, global.bravobit['bb-foundation'] = global.bravobit['bb-foundation'] || {}, global.bravobit['bb-foundation'].api = {}), global.rxjs, global.rxjs.operators, global.ng.core, global.ng.common.http));
}(this, (function (exports, rxjs, operators, core, http) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var ApiConfig = /** @class */ (function () {
        function ApiConfig() {
        }
        return ApiConfig;
    }());

    var DataSourceRequest = /** @class */ (function () {
        function DataSourceRequest() {
            // Data.
            this._request$ = new rxjs.BehaviorSubject(null);
            this._loading$ = new rxjs.BehaviorSubject(true);
        }
        Object.defineProperty(DataSourceRequest.prototype, "loading", {
            get: function () {
                return this._loading$.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataSourceRequest.prototype, "when", {
            get: function () {
                return this._request$.pipe(operators.filter(function (data) { return !!data; }));
            },
            enumerable: true,
            configurable: true
        });
        DataSourceRequest.prototype.startLoading = function () {
            this._loading$.next(true);
        };
        DataSourceRequest.prototype.stopLoading = function () {
            this._loading$.next(false);
        };
        DataSourceRequest.prototype.update = function (params) {
            if (params === void 0) { params = {}; }
            var currentValue = this._request$.getValue();
            // Set the page number to 1 if the query or page size was changed.
            if (currentValue && params && (currentValue.query !== params.query || currentValue.pageSize !== params.pageSize)) {
                params.pageNumber = 1;
            }
            this._request$.next(__assign(__assign({}, currentValue), params));
        };
        return DataSourceRequest;
    }());
    var ApiDataSource = /** @class */ (function () {
        function ApiDataSource() {
        }
        return ApiDataSource;
    }());

    var ApiMapper = /** @class */ (function () {
        function ApiMapper() {
        }
        ApiMapper.prototype.toPageResponse = function (data) {
            return {
                pageSize: data['page_size'],
                pageNumber: data['page_number'],
                totalPages: data['total_pages'],
                totalEntries: data['total_entries'],
                data: data['data']
            };
        };
        ApiMapper.prototype.toPageRequest = function (data) {
            var params = {};
            params['page'] = "" + (data.pageNumber || 1);
            params['page_size'] = "" + (data.pageSize || 25);
            var sort = (data.sort || [])
                .map(function (_a) {
                var name = _a.name;
                return name;
            })
                .filter(function (name) { return !!name; })
                .join(',');
            var sortDirection = (data.sort || [])
                .map(function (_a) {
                var direction = _a.direction;
                return direction;
            })
                .filter(function (direction) { return !!direction; })
                .join(',');
            if (sort.length > 0 && sortDirection.length > 0) {
                params['sort'] = sort;
                params['sort_direction'] = sortDirection;
            }
            if (data.query && data.query.length > 0 && data.queryFields && data.queryFields.length > 0) {
                params['query'] = data.query;
                params['query_fields'] = data.queryFields.join(',');
            }
            return params;
        };
        ApiMapper = __decorate([
            core.Injectable()
        ], ApiMapper);
        return ApiMapper;
    }());

    var Api = /** @class */ (function () {
        function Api(_http, _mapper, _config) {
            this._http = _http;
            this._mapper = _mapper;
            this._config = _config;
            // Validate the config exists.
            if (!this._config) {
                throw new Error('API configuration was not received properly.');
            }
            // Cache the base url.
            this._baseUrl = this._config.baseUrl;
        }
        Api.prototype.page = function (endpoint, params, options) {
            var _this = this;
            if (params === void 0) { params = {}; }
            // Compose the params and headers.
            var pageParams = this._mapper.toPageRequest(params);
            var extraParams = (options && options.params) || {};
            var extraHeaders = (options && options.headers) || {};
            // Return an observable so it can be a stream.
            return this.get(endpoint, {
                headers: extraHeaders,
                params: __assign(__assign({}, pageParams), extraParams)
            }).pipe(operators.map(function (response) { return _this._mapper.toPageResponse(response); }));
        };
        Api.prototype.get = function (endpoint, options) {
            // Add the base url to the endpoint.
            var url = this.toAbsoluteUrl(endpoint);
            // Return an observable so it can be a stream.
            return this._http.get(url, options);
        };
        Api.prototype.post = function (endpoint, body) {
            return __awaiter(this, void 0, void 0, function () {
                var url;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            url = this.toAbsoluteUrl(endpoint);
                            return [4 /*yield*/, this._http.post(url, body).toPromise()];
                        case 1: 
                        // Execute the post call as a promise.
                        return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        Api.prototype.put = function (endpoint, body) {
            return __awaiter(this, void 0, void 0, function () {
                var url;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            url = this.toAbsoluteUrl(endpoint);
                            return [4 /*yield*/, this._http.put(url, body).toPromise()];
                        case 1: 
                        // Execute the put call as a promise.
                        return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        Api.prototype.patch = function (endpoint, body) {
            return __awaiter(this, void 0, void 0, function () {
                var url;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            url = this.toAbsoluteUrl(endpoint);
                            return [4 /*yield*/, this._http.patch(url, body).toPromise()];
                        case 1: 
                        // Execute the patch call as a promise.
                        return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        Api.prototype.delete = function (endpoint) {
            return __awaiter(this, void 0, void 0, function () {
                var url;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            url = this.toAbsoluteUrl(endpoint);
                            return [4 /*yield*/, this._http.delete(url).toPromise()];
                        case 1: 
                        // Execute the delete call as a promise.
                        return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        Api.prototype.toAbsoluteUrl = function (endpoint) {
            return "" + this._baseUrl + endpoint;
        };
        Api.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: ApiMapper },
            { type: ApiConfig, decorators: [{ type: core.Optional }] }
        ]; };
        Api = __decorate([
            core.Injectable(),
            __param(2, core.Optional())
        ], Api);
        return Api;
    }());

    var ApiError = /** @class */ (function () {
        function ApiError(_status, _error) {
            this._status = _status;
            this._error = _error;
        }
        Object.defineProperty(ApiError.prototype, "status", {
            get: function () {
                return this._status;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ApiError.prototype, "error", {
            get: function () {
                return this._error;
            },
            enumerable: true,
            configurable: true
        });
        ApiError.prototype.get = function (token, delimiter) {
            if (delimiter === void 0) { delimiter = '.'; }
            var tokens = (token || '').split(delimiter);
            var result = tokens.reduce(function (previous, token) {
                if (previous && previous[token]) {
                    return previous[token];
                }
                return null;
            }, this._error || {});
            return result;
        };
        ApiError.prototype.has = function (token, delimiter) {
            if (delimiter === void 0) { delimiter = '.'; }
            return !!this.get(token, delimiter);
        };
        ApiError.prototype.includes = function (token, value) {
            var array = this.get(token);
            return (array || []).includes(value);
        };
        return ApiError;
    }());

    var ApiModule = /** @class */ (function () {
        function ApiModule(_parent) {
            if (_parent) {
                throw new Error('ApiModule is already loaded; Import it in the AppModule only.');
            }
        }
        ApiModule_1 = ApiModule;
        ApiModule.forRoot = function (config) {
            return {
                ngModule: ApiModule_1,
                providers: [
                    { provide: ApiConfig, useValue: config },
                    Api
                ]
            };
        };
        var ApiModule_1;
        ApiModule.ctorParameters = function () { return [
            { type: ApiModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
        ]; };
        ApiModule = ApiModule_1 = __decorate([
            core.NgModule({
                imports: [
                    http.HttpClientModule
                ],
                providers: [
                    { provide: ApiMapper, useClass: ApiMapper }
                ]
            }),
            __param(0, core.Optional()), __param(0, core.SkipSelf())
        ], ApiModule);
        return ApiModule;
    }());

    exports.Api = Api;
    exports.ApiConfig = ApiConfig;
    exports.ApiDataSource = ApiDataSource;
    exports.ApiError = ApiError;
    exports.ApiMapper = ApiMapper;
    exports.ApiModule = ApiModule;
    exports.DataSourceRequest = DataSourceRequest;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=bravobit-bb-foundation-api.umd.js.map
