import { IsRequired, IsRequiredConstructor, CanDisable, CanDisableConstructor, IsReadonly, IsReadonlyConstructor, IsGrouped, IsGroupedConstructor, IsFocused, IsFocusedConstructor, HasError, HasErrorConstructor, CanHideErrors, CanHideErrorsConstructor } from '@bravobit/bb-foundation';
import { TemplateRef } from '@angular/core';
import { NgControl } from '@angular/forms';
declare class BbFormControlBase {
}
declare const BbFormControlMixinBase: IsRequiredConstructor & IsGroupedConstructor & IsFocusedConstructor & IsReadonlyConstructor & CanDisableConstructor & HasErrorConstructor & CanHideErrorsConstructor & typeof BbFormControlBase;
export declare class BbFormControl extends BbFormControlMixinBase implements IsRequired, IsFocused, IsReadonly, IsGrouped, CanDisable, HasError, CanHideErrors {
    ngControl: NgControl;
    label: string | TemplateRef<any> | null;
    hint: string | TemplateRef<any> | null;
    arrow: boolean;
    labelId: string;
    onErrorChange(error: {
        token: string;
        data?: any;
    } | null): void;
}
export {};
