import { OnInit } from '@angular/core';
import { CanDisableConstructor } from '@bravobit/bb-foundation';
import { ControlValueAccessor } from '@angular/forms';
import { Observable } from 'rxjs';
declare class BbTablePagerBase {
}
declare const BbTablePagerMixinBase: CanDisableConstructor & typeof BbTablePagerBase;
export declare class BbTablePager extends BbTablePagerMixinBase implements OnInit, ControlValueAccessor {
    amountOfButtons: number;
    showArrowButtons: boolean;
    isPreviousDisabled$: Observable<boolean>;
    isNextDisabled$: Observable<boolean>;
    list$: Observable<{
        page: number;
        active: boolean;
    }[]>;
    onChange: (newValue: number) => void;
    onTouched: () => void;
    trackByIndex: (index: any, item: any) => any;
    private _totalPages$;
    private _pageNumber$;
    ngOnInit(): void;
    get pageNumber(): number;
    set pageNumber(newValue: number);
    get totalPages(): number;
    set totalPages(newValue: number);
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    writeValue(newValue: number): void;
    goToPrevious(): void;
    goToNext(): void;
    goToIndex(index: number): void;
    private update;
    private calculatePages;
    private filterActivePages;
}
export {};
